From: Jan Kiszka <jan.kiszka@siemens.com>
To: isar-users <isar-users@googlegroups.com>
Subject: [PATCH v4 03/13] sdk: Add script to relocate SDK
Date: Wed, 7 Oct 2020 16:01:20 +0200 [thread overview]
Message-ID: <5926e0b8f0d2a70c6dd01d3ad217a92468950a7b.1602079290.git.jan.kiszka@siemens.com> (raw)
In-Reply-To: <cover.1602079290.git.jan.kiszka@siemens.com>
From: Jan Kiszka <jan.kiszka@siemens.com>
When run inside the unpacked SDK, this script tunes interp and rpath
entry in relevant binaries so that the cross conpilation tool can be
called outside of the chroot, irrespective of the host distribution.
Then only "--sysroot /path/to/sdkroot" needs to be passed to the
compiler.
The script also supports restoring the original chroot-mode when invoked
with the --restore-chroot option.
Signed-off-by: Jan Kiszka <jan.kiszka@siemens.com>
---
.../sdkchroot/files/relocate-sdk.sh | 41 +++++++++++++++++++
meta/recipes-devtools/sdkchroot/sdkchroot.bb | 2 +
2 files changed, 43 insertions(+)
create mode 100755 meta/recipes-devtools/sdkchroot/files/relocate-sdk.sh
diff --git a/meta/recipes-devtools/sdkchroot/files/relocate-sdk.sh b/meta/recipes-devtools/sdkchroot/files/relocate-sdk.sh
new file mode 100755
index 00000000..1c9b02fa
--- /dev/null
+++ b/meta/recipes-devtools/sdkchroot/files/relocate-sdk.sh
@@ -0,0 +1,41 @@
+#!/bin/sh
+#
+# This software is a part of ISAR.
+# Copyright (c) Siemens AG, 2020
+#
+# SPDX-License-Identifier: MIT
+
+sdkroot=$(realpath $(dirname $0))
+arch=$(uname -m)
+
+new_sdkroot=$sdkroot
+
+case "$1" in
+--help|-h)
+ echo "Usage: $0 [--restore-chroot|-r]"
+ exit 0
+ ;;
+--restore-chroot|-r)
+ new_sdkroot=/
+ ;;
+esac
+
+if [ -z $(which patchelf 2>/dev/null) ]; then
+ echo "Please install 'patchelf' package first."
+ exit 1
+fi
+
+echo -n "Adjusting path of SDK to '${new_sdkroot}'... "
+
+for binary in $(find ${sdkroot}/usr/bin ${sdkroot}/usr/sbin ${sdkroot}/usr/lib/gcc* -executable -type f); do
+ interpreter=$(patchelf --print-interpreter ${binary} 2>/dev/null)
+ oldpath=${interpreter%/lib*/ld-linux*}
+ interpreter=${interpreter#${oldpath}}
+ if [ -n "${interpreter}" ]; then
+ patchelf --set-interpreter ${new_sdkroot}${interpreter} \
+ --set-rpath ${new_sdkroot}/usr/lib:${new_sdkroot}/usr/lib/${arch}-linux-gnu \
+ $binary 2>/dev/null
+ fi
+done
+
+echo "done"
diff --git a/meta/recipes-devtools/sdkchroot/sdkchroot.bb b/meta/recipes-devtools/sdkchroot/sdkchroot.bb
index 05320a03..5fba09c3 100644
--- a/meta/recipes-devtools/sdkchroot/sdkchroot.bb
+++ b/meta/recipes-devtools/sdkchroot/sdkchroot.bb
@@ -10,6 +10,7 @@ LIC_FILES_CHKSUM = "file://${LAYERDIR_core}/licenses/COPYING.GPLv2;md5=751419260
SRC_URI = " \
file://configscript.sh \
+ file://relocate-sdk.sh \
file://README.sdk"
PV = "0.1"
@@ -59,6 +60,7 @@ ROOTFS_POSTPROCESS_COMMAND =+ "sdkchroot_install_files"
sdkchroot_install_files() {
# Configure root filesystem
sudo install -m 644 ${WORKDIR}/README.sdk ${S}
+ sudo install -m 755 ${WORKDIR}/relocate-sdk.sh ${S}
sudo install -m 755 ${WORKDIR}/configscript.sh ${S}
sudo chroot ${S} /configscript.sh ${DISTRO_ARCH}
}
--
2.26.2
next prev parent reply other threads:[~2020-10-07 14:01 UTC|newest]
Thread overview: 25+ messages / expand[flat|nested] mbox.gz Atom feed top
2020-10-07 14:01 [PATCH v4 00/13] Complete backlog: SDK, assorting fixed and cleanups Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 01/13] sdk: Add support for adding self-defined sdk packages Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 02/13] sdk: Make all links in the SDK chroot relative Jan Kiszka
2020-10-07 14:01 ` Jan Kiszka [this message]
2020-10-15 18:50 ` [PATCH v4 03/13] sdk: Add script to relocate SDK Baurzhan Ismagulov
2020-10-16 6:47 ` Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 04/13] sdk: Make shipping the isar-apt repo opt-in Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 05/13] sdk: Inject sysroot path when calling relocated toolchain Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 06/13] sdk: Update README.sdk Jan Kiszka
2020-10-16 8:18 ` [PATCH v5 " Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 07/13] isar-bootstrap: Connect to gpg-agent before adding keys Jan Kiszka
2020-11-21 7:41 ` Jan Kiszka
2020-12-14 7:03 ` Jan Kiszka
2020-12-16 11:36 ` Baurzhan Ismagulov
2020-12-16 15:53 ` [PATCH v1] isar-bootstrap: Run gpg-agent before starting apt-key Baurzhan Ismagulov
2020-12-16 16:41 ` Jan Kiszka
2021-01-18 17:30 ` Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 08/13] buildchroot-host: Drop unneeded :native for riscv64 setup Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 09/13] deb-dl-dir: Fix quoting Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 10/13] Fix dependencies on isar-apt Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 11/13] dpkg: Account for changes in mk-build-deps in bullseye Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 12/13] isar-bootstrap: Align debootstrap calls Jan Kiszka
2020-10-07 14:01 ` [PATCH v4 13/13] u-boot: Deprecate BUILD_DEPENDS in favor of DEBIAN_BUILD_DEPENDS Jan Kiszka
2020-11-05 14:23 ` [PATCH v4 00/13] Complete backlog: SDK, assorting fixed and cleanups Baurzhan Ismagulov
2020-11-26 15:40 ` Anton Mikanovich
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=5926e0b8f0d2a70c6dd01d3ad217a92468950a7b.1602079290.git.jan.kiszka@siemens.com \
--to=jan.kiszka@siemens.com \
--cc=isar-users@googlegroups.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox